VERSION 5.00
Object = "{08216199-47EA-11D3-9479-00AA006C473C}#2.1#0"; "RMCONTROL.OCX"
Begin VB.Form Form1 
   Caption         =   "3D Park                                            ~Dave"
   ClientHeight    =   5400
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6435
   Icon            =   "Park.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   360
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   429
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer2 
      Index           =   3
      Interval        =   1
      Left            =   3960
      Top             =   3000
   End
   Begin VB.Timer Timer2 
      Index           =   2
      Interval        =   1
      Left            =   3480
      Top             =   3000
   End
   Begin VB.Timer Timer2 
      Index           =   1
      Interval        =   1
      Left            =   3960
      Top             =   2520
   End
   Begin VB.Timer Timer2 
      Index           =   0
      Interval        =   1
      Left            =   3480
      Top             =   2520
   End
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   3000
      Top             =   2520
   End
   Begin RMControl7.RMCanvas RMCanvas1 
      Height          =   5415
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6495
      _ExtentX        =   11456
      _ExtentY        =   9551
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim BirdMesh As Direct3DRMMeshBuilder3
Dim TreeTopMesh As Direct3DRMMeshBuilder3   'will load the treetop mesh
Dim TreeStumpMesh As Direct3DRMMeshBuilder3 'will load the treestump mesh
Dim GroundMesh As Direct3DRMMeshBuilder3 'the ground mesh
Dim FenceMesh As Direct3DRMMeshBuilder3
Dim BenchMesh As Direct3DRMMeshBuilder3

Const NumTrees = 80
Dim TreeTop(NumTrees) As Direct3DRMFrame3 'the frames to hold the treetop mesh
Dim TreeStump(NumTrees) As Direct3DRMFrame3 'the frames to hold the treestump mesh
Dim UpTree As Boolean 'whether up a tree or not
Dim Ground As Direct3DRMFrame3      'the ground frame
Dim Fence(3) As Direct3DRMFrame3 '4 for all 4 walls
Const NumBirds = 20
Dim Bird(NumBirds) As Direct3DRMFrame3 'the birdy frames,will hold
                            'either a regular or a flapping bird
Dim BDest(NumBirds) As D3DVECTOR 'the birds destination
Dim TFrame As Direct3DRMFrame3 'a temporary frame so the birds will look at it
Const NumBenches = 15
Dim Bench(NumBenches) As Direct3DRMFrame3

Dim MSpeed 'movement speed
Const RSpeed = 2 'rotational speed
Const PI = 3.1415926535

Private Sub Form_Load()
ChDir App.Path

With RMCanvas1
    .StartWindowed
    .CameraFrame.SetPosition Nothing, 0, 1, 0
    .Viewport.SetBack (9000) 'set the depth of vision possible
    .SceneFrame.SetSceneBackgroundRGB 0.2, 0.4, 1 'set the background color
    
    Set TreeTopMesh = .D3DRM.CreateMeshBuilder() 'create a mesh object
    Set TreeStumpMesh = .D3DRM.CreateMeshBuilder() 'create a mesh object
    Set GroundMesh = .D3DRM.CreateMeshBuilder() 'create a mesh object
    Set FenceMesh = .D3DRM.CreateMeshBuilder() 'create a mesh object
    Set BirdMesh = .D3DRM.CreateMeshBuilder() 'create a mesh object
    Set BenchMesh = .D3DRM.CreateMeshBuilder() 'create a mesh object
    
    'create the bird frames
    For b = 0 To NumBirds
        Set Bird(b) = .D3DRM.CreateFrame(.SceneFrame)
    Next b
    
    'create the bench frames
    For e = 0 To NumBenches
        Set Bench(e) = .D3DRM.CreateFrame(.SceneFrame)
    Next e
    
    
    Set TFrame = .D3DRM.CreateFrame(.SceneFrame)
        
    Set Ground = .D3DRM.CreateFrame(.SceneFrame)
    For q = 0 To 3
        Set Fence(q) = .D3DRM.CreateFrame(.SceneFrame)
    Next q
    'create the frames for the treetops and treestumps
    For v = 0 To NumTrees
        Set TreeTop(v) = .D3DRM.CreateFrame(.SceneFrame) 'create the treetop frame and set it's parent to the rmcanvas's sceneframe
        Set TreeStump(v) = .D3DRM.CreateFrame(.SceneFrame) 'create the treestump frame and set it's parent to the rmcanvas's sceneframe
    Next v

End With

'load the tree meshes (made of a bottom mesh and a top mesh)
TreeTopMesh.LoadFromFile "treetop.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing
TreeStumpMesh.LoadFromFile "treebot.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing
'load the bench mesh
BenchMesh.LoadFromFile "bench.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing

'load the fence mesh,same mesh as the ground but will be shaped different later
FenceMesh.LoadFromFile "flatbox.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing
Randomize Timer
For q = 0 To 3
    Fence(q).AddScale D3DRMCOMBINE_REPLACE, 0.0001, 0.9, 0.9
    Fence(q).AddVisual FenceMesh
    'tell the fences to use their own color then set that color
    Fence(q).SetMaterialMode D3DRMMATERIAL_FROMFRAME
    Fence(q).SetColorRGB Rnd, Rnd, Rnd 'random color
Next q
'put these two walls on opposite sides
Fence(0).SetPosition Nothing, -510, -1, 0
Fence(1).SetPosition Nothing, 510, -1, 0
'rotate these two walls then put them on opposite sides
Fence(2).SetOrientation Fence(2), 1, 0, 0, 0, 1, 0
Fence(2).SetPosition Nothing, 0, -1, -510
Fence(3).SetOrientation Fence(3), 1, 0, 0, 0, 1, 0
Fence(3).SetPosition Nothing, 0, -1, 510

'load the ground mesh
GroundMesh.LoadFromFile "flatbox.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing

Ground.AddScale D3DRMCOMBINE_BEFORE, 1, 0.001, 1 'make the ground big
Ground.SetMaterialMode D3DRMMATERIAL_FROMFRAME 'tell the mesh to become whatever color I want it to, as opposed to having it be the color of the mesh
Ground.SetColorRGB 0, 1, 0 'make the ground green
Ground.AddVisual GroundMesh 'add the ground mesh to the frame

'load the bird mesh, then bird with flapping wings mesh
BirdMesh.LoadFromFile "bird.x", 0, D3DRMLOAD_FROMFILE, Nothing, Nothing

'load the bird stuff
For b = 0 To NumBirds
    Bird(b).SetMaterialMode D3DRMMATERIAL_FROMFRAME 'tell the frame to be it's own color
    Bird(b).SetColorRGB 0.9, 0, 0 'tell the bird to be a cardinal
    Bird(b).AddVisual BirdMesh 'put the bird mesh in the bird frames
Next b

Randomize Timer
For b = 0 To NumBirds
    'put the birds in random x and z positions
    rx = Int(Rnd * 1000) - 499
    rz = Int(Rnd * 1000) - 499
    Bird(b).SetPosition Nothing, rx, 2, rz
    With BDest(b)
        .x = Int(Rnd * 1000) - 499
        .y = Int(Rnd * 150) + 25
        .z = Int(Rnd * 1000) - 499
    End With
Next b

Randomize Timer
For treeindex = 0 To NumTrees
    'put the trees in random x and z positions
    rx = Int(Rnd * 1000) - 499
    rz = Int(Rnd * 1000) - 499
    TreeTop(treeindex).SetPosition Nothing, rx, 0, rz
    TreeStump(treeindex).SetPosition Nothing, rx, 0, rz
    TreeTop(treeindex).SetMaterialMode D3DRMMATERIAL_FROMFRAME
    TreeStump(treeindex).SetMaterialMode D3DRMMATERIAL_FROMFRAME
    TreeStump(treeindex).SetColorRGB 0.3, 0.3, 0.2
    TreeTop(treeindex).SetColorRGB 0.5, 0.8, 0.1
    
    TreeTop(treeindex).AddVisual TreeTopMesh
    TreeStump(treeindex).AddVisual TreeStumpMesh
Next treeindex
UpTree = -1 ' Not up a tree

Randomize Timer
For e = 0 To NumBenches
    'put the benches in random x and z positions
    rx = Int(Rnd * 1000) - 499
    rz = Int(Rnd * 1000) - 499
    
    Bench(e).SetPosition Nothing, rx, 0, rz
    Bench(e).SetMaterialMode D3DRMMATERIAL_FROMFRAME 'fromframe will make it be whatever color I set the frame at
    Bench(e).SetColorRGB 0.8, 0.4, 0
    Bench(e).AddVisual BenchMesh
Next e

MSpeed = 3 'set the movement speed

RMCanvas1.Update
End Sub

Private Sub Form_Resize()
'if the form resizes, resize the rmcanvas, too
RMCanvas1.Width = Form1.ScaleWidth - RMCanvas1.Left
RMCanvas1.Height = Form1.ScaleHeight - RMCanvas1.Top
End Sub

Private Sub RMCanvas1_KeyPress(KeyAscii As Integer)
Dim CV As D3DVECTOR 'camera vector (position)
Dim TV As D3DVECTOR 'tree vector (position)

RMCanvas1.CameraFrame.GetPosition Nothing, CV 'get the camera's position

'if trying to move x or z positions but up a tree
If UpTree = True Then
If LCase(Chr(KeyAscii)) = "w" Or LCase(Chr(KeyAscii)) = "s" Or LCase(Chr(KeyAscii)) = "a" Or LCase(Chr(KeyAscii)) = "d" Then
    For fall = 1 To CV.y - 1 Step 2
        RMCanvas1.CameraFrame.SetPosition RMCanvas1.CameraFrame, 0, -2, 0
        RMCanvas1.Update
    Next fall
    RMCanvas1.CameraFrame.SetPosition Nothing, CV.x, 1, CV.y
    RMCanvas1.Update
    UpTree = False
    DoEvents
End If
End If

'axal movement
If LCase(Chr(KeyAscii)) = "a" Then Call RMCanvas1.CameraFrame.SetPosition(RMCanvas1.CameraFrame, -MSpeed, 0, 0)
If LCase(Chr(KeyAscii)) = "d" Then Call RMCanvas1.CameraFrame.SetPosition(RMCanvas1.CameraFrame, MSpeed, 0, 0)
If LCase(Chr(KeyAscii)) = "w" Then Call RMCanvas1.CameraFrame.SetPosition(RMCanvas1.CameraFrame, 0, 0, MSpeed)
If LCase(Chr(KeyAscii)) = "s" Then Call RMCanvas1.CameraFrame.SetPosition(RMCanvas1.CameraFrame, 0, 0, -MSpeed)

'climb a tree if near one
If LCase(Chr(KeyAscii)) = "c" Then
    For t = 0 To NumTrees
        TreeStump(t).GetPosition Nothing, TV 'get the tree trunk's position
        If CV.y < 20 Then ' if the camera is not too high in the air
        'check if the camera's vector is near the tree trunk's vector, if so, climb it
        If TV.x - 10 < CV.x And TV.x + 10 > CV.x Then
        If TV.z - 10 < CV.z And TV.z + 10 > CV.z Then
            UpTree = True
            RMCanvas1.CameraFrame.SetPosition RMCanvas1.CameraFrame, 0, 1, 0 'move the camera up 1
        End If
        End If
        End If
    Next t
End If

'rotatation
If LCase(Chr(KeyAscii)) = "j" Then RMCanvas1.CameraFrame.AddRotation D3DRMCOMBINE_BEFORE, 0, 1, 0, -RSpeed * PI / 180
If LCase(Chr(KeyAscii)) = "l" Then RMCanvas1.CameraFrame.AddRotation D3DRMCOMBINE_BEFORE, 0, 1, 0, RSpeed * PI / 180
End Sub

Private Sub Timer1_Timer()
Dim CVec As D3DVECTOR
'get the camera's position
RMCanvas1.CameraFrame.GetPosition Nothing, CVec
'if the camera is out of the park then put it back
If CVec.x > 500 Then RMCanvas1.CameraFrame.SetPosition Nothing, 500, 1, CVec.z
If CVec.x < -500 Then RMCanvas1.CameraFrame.SetPosition Nothing, -500, 1, CVec.z
If CVec.z > 500 Then RMCanvas1.CameraFrame.SetPosition Nothing, CVec.x, 1, 500
If CVec.z < -500 Then RMCanvas1.CameraFrame.SetPosition Nothing, CVec.x, 1, -500

'move the birdies to their destinations
For b = 0 To NumBirds
    Dim BPos As D3DVECTOR
    Bird(b).GetPosition Nothing, BPos 'get the birds position
    If BDest(b).x <> BPos.x Or BDest(b).y <> BPos.y Or BDest(b).z <> BPos.z Then 'if the bird's coordinates are different from it's destination
        TFrame.SetPosition Nothing, BDest(b).x, BDest(b).y, BDest(b).z 'set a temporary frame at the birds destination so the bird will look at it
        
        Bird(b).LookAt TFrame, Nothing, D3DRMCONSTRAIN_Z
        Bird(b).SetPosition Bird(b), 0, 0, 5
    End If
    'if the bird is within 5 to all sides of it's destination
    'then give it a new destination
    If BDest(b).x - 25 < BPos.x And BDest(b).x + 25 > BPos.x Then
    If BDest(b).y - 25 < BPos.y And BDest(b).y + 25 > BPos.y Then
    If BDest(b).z - 25 < BPos.z And BDest(b).z + 25 > BPos.z Then
        Randomize Timer
        With BDest(b)
            .x = Int(Rnd * 1000) - 499
            .y = Int(Rnd * 150) + 25
            .z = Int(Rnd * 1000) - 499
        End With
    End If
    End If
    End If
Next b
End Sub

Private Sub Timer2_Timer(Index As Integer)
'makes sure the rmcanvas stays updated
RMCanvas1.Update
End Sub

